=== debian/changelog ===
cipheycore (0.3.2-0kali3) kali-dev; urgency=medium

  * Use only the default version of Python

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 16 Feb 2024 14:38:20 +0100

cipheycore (0.3.2-0kali2) kali-dev; urgency=medium

  * Fix test for i386

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 09 Oct 2023 14:19:41 +0200

cipheycore (0.3.2-0kali1) kali-dev; urgency=medium

  * Initial release.

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 05 Oct 2023 11:07:37 +0200
