=== debian/control ===
Source: cipheycore
Section: python
Priority: optional
Maintainer: Kali Developers <devel@kali.org>
Uploaders: Sophie Brun <sophie@offensive-security.com>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 python3-setuptools,
 python3-all-dev,
 libboost-dev,
 swig,
 libgtest-dev,
 cmake
Standards-Version: 4.6.2
Homepage: https://github.com/Ciphey/CipheyCore
Vcs-Browser: https://gitlab.com/kalilinux/packages/cipheycore
Vcs-Git: https://gitlab.com/kalilinux/packages/cipheycore.git

Package: python3-cipheycore
Architecture: any
Multi-Arch: foreign
Depends:
 ${python3:Depends},
 ${misc:Depends},
 ${shlibs:Depends},
Description: many crackers, encryption methods & decryption methods (Python 3)
 This package provides many crackers, encryption methods & decryption methods
 as well as cryptanalysis tidbitis to Ciphey.
 .
 This package installs the library for Python 3.
