=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE = 1

export PYBUILD_NAME=cipheycore
PYTHON_VERSION=$(shell py3versions -d | sed s/python//)

%:
	dh $@

override_dh_auto_configure:
	 dh_auto_configure -- -DCMAKE_SKIP_RPATH=ON -DPYTHON_CIPHEY_VERSION=$(PYTHON_VERSION)
	 sed -e "s/PYTHON_VERSION/$(PYTHON_VERSION)/" $(CURDIR)/debian/tests/basic
